#include "audio_buffer_pool.h"

#include "audio/mixer/mixer.h"

IMPL_SINGLETON_INSTANCE(audio_buffer_pool)

void audio_buffer_pool::init(singleton_initliazer& initliazer) {
}

void audio_buffer_pool::release(singleton_release_guard& release_guard) {
    singleton_t<audio_buffer_pool>::release(release_guard);
    for (auto& pool : pool_map_) {
        delete pool.second;
    }
}

sample_t* audio_buffer_pool::alloc(uint32_t block_size) {
    if (pool_map_.find(block_size) == pool_map_.end()) {
        pool_map_.emplace(block_size, new memory_pool(sizeof(sample_t) * block_size, 256));
    }
    return static_cast<sample_t*>(pool_map_[block_size]->allocate());
}

void audio_buffer_pool::free(sample_t* block, uint32_t block_size) {
    pool_map_[block_size]->deallocate(block);
}
