#pragma once
#include "extern.h"
#include <string>
#include <cstdint>
#include <optional>

class plugin_host;

class CORE_API host_param
{
public:
	host_param(plugin_host* host, int32_t index);
	[[nodiscard]] int32_t get_index() const { return index_; }
	[[nodiscard]] const std::string& get_name() const;
    [[nodiscard]] const std::string& get_label() const;
    [[nodiscard]] const std::string& get_display() const;
	[[nodiscard]] bool is_valid() const { return is_valid_; }
	void set_value(float in_value);
	[[nodiscard]] float get_value() const;
    [[nodiscard]] float min_value() const;
    [[nodiscard]] float max_value() const;
    [[nodiscard]] bool is_toggle() const;

	explicit operator bool() const {
		return is_valid();
	}
private:
	int32_t index_ = -1;
	mutable std::string name_;
    mutable std::string label_;
    mutable std::string display_;
    mutable std::optional<bool> is_toggle_;
	plugin_host* host_;
	bool is_valid_ = false;
};
