#pragma once
#include <thread>

#include "thread_message_hub.h"

CORE_API extern thread_message_hub g_main_thread_hub;
CORE_API extern thread_message_hub g_audio_thread_hub;

CORE_API extern std::thread::id g_main_thread_id;
CORE_API extern std::thread::id g_audio_thread_id;

#define PUSH_MAIN_THREAD(code) g_main_thread_hub.push_message(code);

#define IS_MAIN_THREAD() (std::this_thread::get_id() == g_main_thread_id)
#define IS_AUDIO_THREAD() (std::this_thread::get_id() == g_audio_thread_id)
